Core - Task # 59015

Story # 58777 (Accepted): Fixes/Tasks for impexp / distributions

Status: Resolved Priority: Should have

Author: Marc Bastian Heinrichs Category: Import/Export (T3D)
Created: 2014-05-21 Assigned To: Marc Bastian Heinrichs
Updated: 2015-03-05 Due date:

TYPOS3 Version: 6.2

PHP Version:

Complexity:

Sprint Focus:

Subject: Catch all errors on adding files of sys_files to export

Description

Adding files from sys_file records is not robust enough.

E.g. if there are sys_file records, but no related files anymore, what

could happen for files in /uploads/tx_foo till #58967 is fixed a RuntimeException
is thrown.

Solution: catch all Exceptions thrown from Resources in export_addSysFile

Associated revisions

Revision 3b86ba55 - 2015-03-05 20:48 - Marc Bastian Heinrichs

[BUGFIX] Catch all errors on adding files of sys_files to export

Adding files from sys_file records is not robust enough. For example
sys_file records could exist for already deleted files. In this case a
RuntimeException is thrown, which is not caught currently.

Solution: catch all Exceptions thrown from Resources in
export_addSysFile and report them to the user.

Resolves: #59015

Releases: master, 6.2

Change-Id: If7ce51a2ae756b43dc30d5545b076310972342f4
Reviewed-on: http:/review.typo3.org/30318

Reviewed-by: Frans Saris <franssaris@gmail.com>

Tested-by: Frans Saris <franssaris@gmail.com>

Reviewed-by: Stephan GroBberndt <stephan@grossberndt.de>

Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

Revision 844dc392 - 2015-03-05 20:53 - Marc Bastian Heinrichs
[BUGFIX] Catch all errors on adding files of sys_files to export
Adding files from sys_file records is not robust enough. For example

sys_file records could exist for already deleted files. In this case a
RuntimeException is thrown, which is not caught currently.
Solution: catch all Exceptions thrown from Resources in

export_addSysFile and report them to the user.

Resolves: #59015

Releases: master, 6.2

Change-Id: [f7ce51a2ae756b43dc30d5545b076310972342f4
Reviewed-on: http://review.typo3.org/37566

Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

History

#1 - 2014-05-22 10:32 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/30318

#2 - 2014-05-22 11:25 - Armin Ruediger Vieweg
- File 2014-05-22_1124.png added

I've tested it, now | get this warning in ImpExp module:
Core: Error handler (BE): PHP Warning: fileperms(): stat failed for /var/www/vhosts/.../htdocs/htdocs
in /var/www/t3sources/typo3_src-6.2.2/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php line 1097

And for every time | open the ImpExp module again (for root node) another warning appears:
/Ay PHP Warning
PHP Warning: fileperms(): stat failed for /var/www/vhosts/typo3sz/htdocs/htdocs in fvar/www/t3sources/ftypo3_src-
6.2.2/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php line 1097

/% PHP Warning
PHP Warning: fileperms(): stat failed for /var/www/vhosts/typo3sz/htdocs/htdocs in fvar/www/t3sources/typo3_src-
6.2.2/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php line 1097

/4 PHP Warning
PHP Warning: fileperms(): stat failed for /var/www/vhosts/typo3sz/htdocs/htdocs in fvar/www/t3sources/typo3_src-
6.2.2/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php line 1097

/Ay PHP Warning
PHP Warning: fileperms(): stat failed for /var/www/vhosts/typo3sz/htdocs/htdocs in fvar/fwww/t3sources/ftypo3_src-
6.2.2/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php line 1097

/Ay PHP Warning
PHP Warning: fileperms(): stat failed for /var/www/vhosts/typo3sz/htdocs/htdocs in fvar/www/t3sources/ftypo3_src-
6.2.2/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php line 1097

/% PHP Warning
PHP Warning: fileperms(): stat failed for /var/www/vhosts/typo3sz/htdocs/htdocs in fvar/www/t3sources/typo3_src-
6.2.2/typo3/sysext/core/Classes/Resource/Driver/LocalDriver.php line 1097

Import / Export

In this example I've opened the module six times. I've also opened it on other pages, then it works. But when | switch back to root, a new warning
appears additionally.

#3 - 2014-05-22 11:35 - Marc Bastian Heinrichs
Ok, thx for testing. Perhaps we should prevent php warnings for fileperms...

Could give some details? You are on Win or Linux? What storages are configured?

#4 - 2014-06-20 23:08 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/30318

#5 - 2014-12-17 19:48 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/30318

#6 - 2015-03-05 20:25 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/30318
#7 - 2015-03-05 20:52 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/37566

#8 - 2015-03-05 21:00 - Marc Bastian Heinrichs
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:3b86ba556219921a5700217b3c25dedde8d6b0db.
